#define VENTRY_NUMBER 64
#define H_VAR_NUMBER 4096
#define ID_VARIANTSTART 1000
#define LEFT_MAX (VENTRY_NUMBER/2-1)
#define RIGHT_START VENTRY_NUMBER/2

class SingleVisualEntry2
    {
    public:
	SingleVisualEntry2();
	int qNumber;
	RECT task;
	RECT variants;
	HWND hVariant[H_VAR_NUMBER];
	HWND hOK;
	bool visible;
    };

class Screen2
    {
    public:
    Screen2();
    RECT rMainWindow;
    SingleVisualEntry2 Entry[VENTRY_NUMBER];
    HINSTANCE hInst;
    HWND hWnd;
    HWND hOwned;
    HFONT hCorrect,hMissing,hExcessive;
    int tmAveCharWidth;
    int CurrentPosition;
    float fChar_test;
    void Init();
    bool PlaceQuestion(int ToInsert, bool bReset,int nVariantsHeight);
    void InsertPosition(int nPosition);
    void HideAll();
    void RemoveInvisible();
    void Cleaner();
//    void WM_PaintTask(HDC hDC,char *task);
void WM_PaintTask(HDC hDC,char *task);
bool CreateMenuItem
	(
	HMENU hMenu,
	char* str,
	UINT uID,
	UINT wID,
	HMENU hSubMenu
	);
    int nID;
    };

Screen2::Screen2()
    {
    TEXTMETRIC tmTM;

    int nID=ID_VARIANTSTART-1;
    CurrentPosition=-1;
    GetClientRect(hWnd,&rMainWindow);
    HDC hDC=GetDC(hWnd);
    GetTextMetrics(hDC,&tmTM);
    ReleaseDC(hWnd,hDC);
    tmAveCharWidth=tmTM.tmAveCharWidth;
    fChar_test=rMainWindow.right/2;
    fChar_test=fChar_test/tmAveCharWidth;
    }

void Screen2::InsertPosition(int nPosition)
    {
    int nStart;
    if(nPosition<LEFT_MAX) nStart=LEFT_MAX;
    else if(nPosition>RIGHT_START) nStart=VENTRY_NUMBER-1;
    else nStart=0;
    for(int i=nStart;i>nPosition;i--)
	{
        Entry[i].qNumber=Entry[i-1].qNumber;
        Entry[i].task=Entry[i-1].task;
        Entry[i].variants=Entry[i-1].variants;
        Entry[i].visible=Entry[i-1].visible;
        for(int j=0;j<VAR_NUMBER;j++) {Entry[i].hVariant[j]=Entry[i-1].hVariant[j];}
        Entry[i].hOK=Entry[i-1].hOK;
	}
    for(int j=0;j<VAR_NUMBER;j++) {Entry[nPosition].hVariant[j]=NULL;}
    Entry[nPosition].hOK=NULL;
    }

void Screen2::Init()
{
hCorrect=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hMissing=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	1,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hExcessive=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	400,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	1,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
}

bool Screen2::CreateMenuItem
	(
	HMENU hMenu,
	char* str,
	UINT uID,
	UINT wID,
	HMENU hSubMenu
	)
    {
    MENUITEMINFO mi;
    mi.cbSize = sizeof(MENUITEMINFO);
    mi.fMask = MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU|MIIM_ID;
    mi.fType = MFT_STRING;
    mi.fState = MFS_ENABLED;
    mi.dwTypeData = str;
    mi.cch = sizeof(str);
    mi.wID = wID;
    mi.hSubMenu = hSubMenu;
    return InsertMenuItem(hMenu, uID, FALSE, &mi);
    }

SingleVisualEntry2::SingleVisualEntry2()
    {
	for(int i=0;i<VAR_NUMBER;i++) hVariant[i]=NULL;
	hOK=NULL;
	qNumber=-1;
	task.left=0;
	task.right=0;
	task.top=0;
	task.bottom=0;
	variants.left=0;
	variants.right=0;
	variants.top=0;
	variants.bottom=0;
	visible=FALSE;
    }

void Screen2::WM_PaintTask(HDC hDC,char *task)
    {
    SetBkMode(hDC,TRANSPARENT);
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
    if(Entry[i].visible)
    DrawText(
	hDC,
	task,
	strlen(task),
	&Entry[i].task,
	DT_WORDBREAK);
    }
    }

void Screen2::HideAll()
    {
    for(int i=0;i<VENTRY_NUMBER;i++) {Entry[i].visible=FALSE;}
    CurrentPosition=-1;
    }

void Screen2::RemoveInvisible()
    {
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
	if((!Entry[i].visible)&(Entry[i].qNumber!=-1))
	{
	InvalidateRect(hWnd, &Entry[i].task,1);
	for(int j=0;j<VAR_NUMBER;j++)
	{
//		if(Topic_test.Get(Entry[i].qNumber)->variant[j].loaded)
//		{
		if(Entry[i].hVariant[j]!=NULL) {DestroyWindow(Entry[i].hVariant[j]);Entry[i].hVariant[j]=NULL;}
//		}
	}
	}
	if(i!=CurrentPosition)
	{
	if(Entry[i].hOK!=NULL) {DestroyWindow(Entry[i].hOK);Entry[i].hOK=NULL;}
	}
	UpdateWindow(hWnd);
    }
    }

void Screen2::Cleaner()
    {
    HWND hWndFind;
    do
    {
        hWndFind=GetWindow(hWnd,GW_CHILD);
        if(hWndFind!=NULL) DestroyWindow(hWndFind);
    }
    while(hWndFind!=NULL);
    }
